// The code that opens the door  RFID tag combo

//ZUNO_SETUP_ASSOCIATIONS(ZUNO_ASSOCIATION_GROUP_DOORLOCK);
ZUNO_SETUP_CHANNELS(ZUNO_SENSOR_BINARY(ZUNO_SENSOR_BINARY_TYPE_GENERAL_PURPOSE, getter));

byte statusKey=0x00;

unsigned long millisOK = 0;
// buffer array for data receive over serial port
unsigned int buffer[15]; 
// counter for buffer array
int count = 0;
// time wait packet             
unsigned long millis1 = 0; 
// the code RFID tag combo that opens the door 
unsigned int rfid_ok[14] = 
    {0x2,0x30,0x31,0x30,0x30,0x30,0x37,0x30,0x36,0x30,0x35,0x30,0x35,0x3};

void setup() {
    Serial.begin();          // the USB Serial
    Serial0.begin(9600);     // the Serial port of rfid reader
}
 
void loop() {
    // read data from rfid reader
    if (Serial0.available()) {            
        millis1 = millis();
        // read into buffer
        buffer[count] = Serial0.read();
        count++;     
    }    
    if (millis() - millis1 > 1000 && count > 0) {
        // write rfid tag combo code
        for (int i = 0; i < count; i++) { 
            Serial.print(buffer[i], HEX);  
            Serial.print(" ");
        }
        // code review
        if (control_rfid()) {
            Serial.println("OK!!!");
            // command to controller
            statusKey=0xff;
            zunoSendReport(1);
            millisOK=millis();
        } else {
            statusKey=0x00;
            zunoSendReport(1);
            Serial.println("NO!!!");
        }       
        clearBufferArray();
        millis1 = millis();
        count = 0;
    } 
    if(statusKey==0xff && (millis()-millisOK >= 10000)) {
        statusKey=0x00;
        zunoSendReport(1);         
    }
}

// function to clear buffer array
void clearBufferArray() {
    for (int i = 0; i < 14; i++) {
        buffer[i] = NULL;
    }                  
}

// function code review
boolean control_rfid() {
    int count1;
  
    count1 = 0;
    for (int i = 0; i < 14; i++) {
        if (buffer[i] == rfid_ok[i]) {
            count1++;
        }
    }
    if (count1 == 14) {
        return true;
    }
  return false;                
}

byte getter(void) {
    return statusKey;
}
